/*
 * Copyright (c) 1993-1995 by Argonaut Technologies Limited. All rights reserved.
 *
 * $Id: colour.h 1.1 1996/09/12 14:02:37 NIKH Exp $
 * $Locker: $
 *
 * Colour type and macros
 *
 */
#ifndef _COLOUR_H_
#define _COLOUR_H_

#ifdef __cplusplus
extern "C" {
#endif

typedef unsigned long int br_colour;

#define BR_COLOUR_RGB(r,g,b) \
		((((unsigned int)(r))<<16) |\
		(((unsigned int)(g))<<8) |\
		((unsigned int)(b)))

#define BR_COLOUR_RGBA(r,g,b,a) \
		((((unsigned int)(a))<<24) |\
		((((unsigned int)(r))<<16) |\
		(((unsigned int)(g))<<8) |\
		((unsigned int)(b)))

#define BR_COLOUR_BGR(r,g,b) \
		(((unsigned short)b << 7) & 0x7c00) |\
		(((unsigned short)g << 2) & 0x3e0) |\
		((unsigned short)r >> 3)

#define BR_COLOUR_ABGR(a,r,g,b) \
		((unsigned short)a << 15) |\
		(((unsigned short)b << 7) & 0x7c00) |\
		(((unsigned short)g << 2) & 0x3e0) |\
		((unsigned short)r >> 3)


#define BR_ALPHA(c) ((c >> 24) & 0xFF)
#define BR_RED(c) (((unsigned int)c >> 16) & 0xFF)
#define BR_GRN(c) (((unsigned int)c >> 8) & 0xFF)
#define BR_BLU(c) (((unsigned int)c) & 0xFF)

#define BR_ALPHA_S(c) (((unsigned short)c >> 15) & 0x1)
#define BR_RED_S(c) (((unsigned short)c << 3) & 0xff)
#define BR_GRN_S(c) (((unsigned short)c >> 2) & 0xf8)
#define BR_BLU_S(c) (((unsigned short)c >> 7) & 0xf8)

#ifdef __cplusplus
};
#endif
#endif

