/*
 * Copyright (c) 1993-1995 by Argonaut Technologies Limited. All rights reserved.
 *
 * $Id: fmtproto.h 1.1 1996/09/12 14:02:39 NIKH Exp $
 * $Locker: $
 *
 * Function prototypes for foreign file format support
 */
#ifndef _FMTPROTO_H_
#define _FMTPROTO_H_

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Eric Haines' NFF format
 */
br_model * BR_PUBLIC_ENTRY BrFmtNFFLoad(const char *name);

/*
 * 3D Studio .ASC files
 */
br_uint_32 BR_PUBLIC_ENTRY BrFmtASCLoad(const char *name, br_model **mtable, br_uint_16 max_models);

/*
 * Script files
 */
br_uint_32 BR_PUBLIC_ENTRY BrFmtScriptMaterialLoadMany(char *filename,br_material **materials,br_uint_16 num);
br_material * BR_PUBLIC_ENTRY BrFmtScriptMaterialLoad(char *filename);

br_uint_32 BR_PUBLIC_ENTRY BrFmtScriptMaterialSaveMany(char *filename,br_material **materials,br_uint_16 num);
br_uint_32 BR_PUBLIC_ENTRY BrFmtScriptMaterialSave(char *filename, br_material *ptr);

/*
 * Windows .BMP files
 */
br_pixelmap * BR_PUBLIC_ENTRY BrFmtBMPLoad(const char *name,br_uint_32 flags);

/*
 * .TGA files
 */
br_pixelmap * BR_PUBLIC_ENTRY BrFmtTGALoad(const char *name,br_uint_32 flags);

/*
 * .GIF files
 */
br_pixelmap * BR_PUBLIC_ENTRY BrFmtGIFLoad(const char *name,br_uint_32 flags);

/*
 * .IFF/.LBM files
 */
br_pixelmap * BR_PUBLIC_ENTRY BrFmtIFFLoad(const char *name,br_uint_32 flags);

/*
 * .TIM (PlayStation) files
 */
br_pixelmap * BR_PUBLIC_ENTRY BrFmtTIMLoad(const char *name,br_uint_32 flags);

/*
 * .TMD (PlayStation) files
 */
br_uint_32 BR_PUBLIC_ENTRY BrFmtTMDLoadMany(const char *filename,br_model **models,br_uint_16 num);

#ifdef __cplusplus
};
#endif
#endif


