/*
 * Copyright (c) 1993-1995 by Argonaut Technologies Limited. All rights reserved.
 *
 * $Id: order.h 1.1 1996/09/12 14:02:43 NIKH Exp $
 * $Locker: $
 *
 * Definitons for an Order table
 */
#ifndef _ORDER_H_
#define _ORDER_H_

#ifdef __cplusplus
extern "C" {
#endif

/*
 * sort type
 */
enum {
	BR_SORT_FIRST_VERTEX,
	BR_SORT_MIN,
	BR_SORT_MAX,
	BR_SORT_AVERAGE,
};

enum {
	BR_ORDER_TABLE_LEAVE_BOUNDS	= 0x0001,
	BR_ORDER_TABLE_NEW_BOUNDS,
	BR_ORDER_TABLE_INIT_BOUNDS,
	
	BR_ORDER_TABLE_CONVEX		= 0x0010,
	BR_ORDER_TABLE_SORT_BUCKETS	= 0x0020,
	
	BR_ORDER_TABLE_SORT_NEAR	= 0x0100,
	BR_ORDER_TABLE_SORT_CENTRE	= 0x0200,
	BR_ORDER_TABLE_SORT_FAR		= 0x0300,
};

/*
 * Definition of order table structure
 */
typedef struct br_order_table {

	/*
	 * order table array
	 */
        void **table;

	/*
	 * number of entries in array
	 */
	br_uint_16 size;

	struct br_order_table *next;

	br_scalar min_z;
	br_scalar max_z;

	br_scalar sort_z;

	br_uint_16 type;

	br_uint_32 flags;

} br_order_table;

#ifdef __cplusplus
};
#endif
#endif
