/*
 * Copyright (c) 1993-1995 Argonaut Technologies Limited. All rights reserved.
 *
 * $Id: psio.h 1.1 1996/09/12 13:56:43 NIKH Exp $
 * $Locker: $
 *
 * Definitions for PS I/O library
 */
#ifndef _PSIO_H_
#define _PSIO_H_

#ifdef __cplusplus
extern "C" {
#endif

/*
 * PSGfxBegin flags
 */
enum {
    	PS_GFX_SINGLE_BUFFER		= 0x0001,
	PS_GFX_DOUBLE_BUFFER		= 0x0002,
};

/*
 * double buffer callback type
 */
typedef void BR_CALLBACK ps_gfx_double_buffer_cbfn(br_uint_8 db_index);

/*
 * draw sync callback type
 */
typedef void BR_CALLBACK ps_gfx_draw_sync_cbfn(br_uint_8 db_index);

/*
 * vsync callback type
 */
typedef void BR_CALLBACK ps_gfx_vsync_cbfn(br_uint_8 db_index);


/*
 * function prototypes
 */
br_pixelmap * BR_PUBLIC_ENTRY PSGfxBegin(brps_draw_environment *draw_env,
				brps_display_environment *disp_env,
				void *primitive,
				br_uint_32 primitive_size,
				br_uint_32 flags);
				
void BR_PUBLIC_ENTRY PSGfxEnd(void);

br_uint_8 BR_PUBLIC_ENTRY PSGfxDoubleBufferIndexRead(void);

ps_gfx_double_buffer_cbfn * BR_PUBLIC_ENTRY PSGfxDoubleBufferCallbackSet(ps_gfx_double_buffer_cbfn *new_cbfn);

ps_gfx_draw_sync_cbfn * BR_PUBLIC_ENTRY PSGfxDrawSyncCallbackSet(ps_gfx_draw_sync_cbfn *new_cbfn);

ps_gfx_vsync_cbfn * BR_PUBLIC_ENTRY PSGfxVSyncCallbackSet(ps_gfx_vsync_cbfn *new_cbfn);


#ifdef __cplusplus
};
#endif

#endif
