#
# Makefile for BRender demos
#
CC	= ccpsx
AS	= asmpsx
LD	= psylink

#
# assembler/compiler flags
#
ASMFLAGS = /l /o c+,h+ /zd

CFLAGS		= -c -g -D__PS__=1
#CFLAGS		= -c -O2 -D__PS__=1
EXTRA_CFLAGS	= -D_NTSC

BASE_LDFLAGS	= /c /m /x __SN_ENTRY_POINT
#BASE_LDFLAGS	= /c /x __SN_ENTRY_POINT

EXTRA_LDFLAGS	= /o$80020000

SRCS		= harness.c support.c
SRCS1		= psyqfile.c psyqerr.c

#
# BRender include path
#
INCLUDES	= -Ie:\velsrc\brpsx\inc -Ie:\velsrc\brpsx\psio

#
# Build dependencies
#
harness:
	$(AS) $(ASMFLAGS) heapbase, heapbase, heapbase
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) $(SRCS)
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) $(SRCS1)

sample0:
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) sample0.c
	$(LD) $(BASE_LDFLAGS) $(EXTRA_LDFLAGS) @sample0.lnk,sample0.cpe,sample0,sample0

sample1:
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) sample1.c
	$(LD) $(BASE_LDFLAGS) $(EXTRA_LDFLAGS) @sample1.lnk,sample1.cpe,sample1,sample1

sample2:
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) sample2.c
	$(LD) $(BASE_LDFLAGS) $(EXTRA_LDFLAGS) @sample2.lnk,sample2.cpe,sample2,sample2

sample3:
	$(CC) -D_BACKGROUND $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) support.c
	$(CC) -D_BACKGROUND $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) sample3.c
	$(LD) $(BASE_LDFLAGS) $(EXTRA_LDFLAGS) @sample3.lnk,sample3.cpe,sample3,sample3

sample4:
	$(CC) -D_BACKGROUND $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) support.c
	$(CC) -D_BACKGROUND $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) sample4.c
	$(LD) $(BASE_LDFLAGS) $(EXTRA_LDFLAGS) @sample4.lnk,sample4.cpe,sample4,sample4

sample5:
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) support.c
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) sample5.c
	$(LD) $(BASE_LDFLAGS) $(EXTRA_LDFLAGS) @sample5.lnk,sample5.cpe,sample5,sample5

sample6:
	$(CC) -D_BACKGROUND $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) support.c
	$(CC) -D_BACKGROUND $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) sample6.c
	$(LD) $(BASE_LDFLAGS) $(EXTRA_LDFLAGS) @sample6.lnk,sample6.cpe,sample6,sample6

sample7:
	$(CC) -D_BACKGROUND $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) support.c
	$(CC) -D_BACKGROUND $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) sample7.c
	$(LD) $(BASE_LDFLAGS) $(EXTRA_LDFLAGS) @sample7.lnk,sample7.cpe,sample7,sample7

sample8:
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) support.c
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) sample8.c
	$(LD) $(BASE_LDFLAGS) $(EXTRA_LDFLAGS) @sample8.lnk,sample8.cpe,sample8,sample8

sample9:
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) sample9.c
	$(LD) $(BASE_LDFLAGS) $(EXTRA_LDFLAGS) @sample9.lnk,sample9.cpe,sample9,sample9

sample10:
	$(CC) -D_SAMPLE10 $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) support.c
	$(CC) -D_SAMPLE10 $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) sample10.c
	$(LD) $(BASE_LDFLAGS) $(EXTRA_LDFLAGS) @sample10.lnk,sample10.cpe,sample10,sample10

sample11:
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) support.c
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) sample11.c
	$(LD) $(BASE_LDFLAGS) $(EXTRA_LDFLAGS) @sample11.lnk,sample11.cpe,sample11,sample11

sample12:
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) support.c
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) sample12.c
	$(LD) $(BASE_LDFLAGS) $(EXTRA_LDFLAGS) @sample12.lnk,sample12.cpe,sample12,sample12

sample13:
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) sample13.c
	$(LD) $(BASE_LDFLAGS) $(EXTRA_LDFLAGS) @sample13.lnk,sample13.cpe,sample13,sample13

sample14:
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) support.c
	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) $(INCLUDES) $(EXTRA_INCLUDES) sample14.c
	$(LD) $(BASE_LDFLAGS) $(EXTRA_LDFLAGS) @sample14.lnk,sample14.cpe,sample14,sample14

clean:
	del *.obj
	del *.map
	del *.sym
