/*
 * Copyright (c) 1996 by Argonaut Technologies Limited. All rights reserved.
 *
 * $Id: PSYQERR.C 1.1 1996/09/12 14:01:13 NIKH Exp $
 * $Locker: $
 *
 * Diagnostic handler that reports errors through PSYQ fileserver functions
 */
#include <sys/types.h>
#include <r3000.h>
#include <asm.h>
#include <kernel.h>
#include <libgte.h>
#include <libgpu.h>
#include <libetc.h>
#include <libsn.h>

#include "brender.h"
#include "psio.h"

static char rscid[] = "$Id: PSYQERR.C 1.1 1996/09/12 14:01:13 NIKH Exp $";

extern br_pixelmap *back_screen[2];
extern br_pixelmap *screen;

#define MAX_WIDTH	32		/* maximum width of one line of error message */

static void BR_CALLBACK PsyqWarning(char *message)
{
	int length, index, width;

	FntLoad(960, 256);				/* font load */
	SetDumpFnt(FntOpen(32, 32, 320, 240, 0, 200)); /* stream open & define */

	length = strlen(message);

	if(length >= MAX_WIDTH) {

		/*
		 * put some line breaks in message
		 */    
		for(index = 0; length >= MAX_WIDTH; ) {

			/*
			 * break before a word if possible
			 */
			for(width = MAX_WIDTH; (message[index + width] != ' ') && (width > 1); width--);

		    	message[index + width] = '\n';
			
			index += width;
			length -= width;
		}
	}

	FntPrint(message);

	DrawSync(0);
	VSync(0);

	FntFlush(-1);

	BrPixelmapDoubleBuffer(screen, back_screen[PSGfxDoubleBufferIndexRead()]);
	
	FntPrint(message);

	DrawSync(0);
	VSync(0);
	
	FntFlush(-1);

	BrPixelmapDoubleBuffer(screen, back_screen[PSGfxDoubleBufferIndexRead()]);

	/*
	 * Warnings are not usually fatal
	 */
	exit(10);
}

/*
 * text message on red background
 */
static void BR_CALLBACK PsyqFailure(char *message)
{
	int length, index, width;

	FntLoad(960, 256);				/* font load */
	SetDumpFnt(FntOpen(32, 32, 320, 240, 0, 200)); /* stream open & define */

	length = strlen(message);

	if(length >= MAX_WIDTH) {

		/*
		 * put some line breaks in message
		 */    
		for(index = 0; length >= MAX_WIDTH; ) {

			/*
			 * break before a word if possible
			 */
			for(width = MAX_WIDTH; (message[index + width] != ' ') && (width > 1); width--);

		    	message[index + width] = '\n';
			
			index += width;
			length -= width;
		}
	}

	FntPrint(message);

	DrawSync(0);
	VSync(0);

	FntFlush(-1);

	BrPixelmapDoubleBuffer(screen, back_screen[PSGfxDoubleBufferIndexRead()]);
	
	FntPrint(message);

	DrawSync(0);
	VSync(0);
	
	FntFlush(-1);

	BrPixelmapDoubleBuffer(screen, back_screen[PSGfxDoubleBufferIndexRead()]);

	exit(10);
}

/*
 * DiagnosticHandler structure
 */
br_diaghandler PsyqDiagHandler={
	"Psyq PS Diagnostic Handler",
	PsyqWarning,
	PsyqFailure,
};

